/* Proiect PM -Snake
 *
 * Marin Maria-Georgiana, 334CC
 */

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>

#include "nokia5110.h"

#define WIDTH  84
#define HEIGHT 48
#define INITIAL_SIZE 3
#define MAX_SIZE     100
#define BLOCK_SIZE 4
#define UP 1
#define RIGHT 2
#define DOWN 3
#define LEFT 4

typedef struct {
	int x;
	int y;
} coord;

static coord snake[100];

int direction = RIGHT;
int head, last_head, tail, alive, score_win;
coord food, extra_food, magic_food, extra_life, trap;
int level, start, score, snake_size;
int extraFood, magicFood, extraLife, Trap;
int finished;
char buff[10];


void music_play(float duration, float frequency)
 {
   	long int i,cycles;
  	float half_period; 
  	float wavelength;
   
 	wavelength=(1/frequency)*1000; 
   	cycles=duration/wavelength; 
   	half_period = wavelength/2; 
 	DDRA |= (1 << PA6);
 
  	for (i=0;i<cycles;i++) 
  	{
  	 _delay_ms(half_period); 
    PORTA |= (1 << PA6); 
     _delay_ms(half_period); 
    PORTA &= ~(1 << PA6); 
   	}
}

void tone1() {
  music_play(659, 250);   // Frequency = 659Hz, duration = 250ms
}

void tone2() {
  music_play(698, 250);   // Frequency = 698Hz, duration = 250ms
}

void tone3() {
  music_play(784, 250);   // Frequency = 784Hz, duration = 250ms
}

void melody1() {                              // Plays the melody "Yellow house"
  tone1(); tone2(); tone3(); tone3();
  tone1(); tone2(); tone3(); tone3();
  tone1(); tone2(); tone3();
  tone1(); tone2(); tone3(); tone3();
  tone1(); tone2(); tone3();
  tone3(); tone3(); tone2(); tone2(); tone1();
}

void toneA() {
  music_play( 880, 50);
}
void toneC() {
  music_play(1046, 50);
}
void toneE() {
  music_play(1318, 50);
}

void melody2() {                // Plays melody2
 unsigned short i;
  for (i = 9; i > 0; i--) {
    toneA(); 
    toneC(); 
    toneE();
    }
}

void melody3() {
	music_play(400,880);  // Musical note 880 Hz
  	music_play(400,932);
 	music_play(400,988);
  	music_play(400,1047);
  	music_play(400,1109);
  	music_play(400,1175);
   	music_play(400,1244);
 	music_play(400,1319);
  	music_play(400,1397);
  	music_play(400,1480);
   	music_play(400,1568);
   	music_play(400,1660);
}

void buzzer_init(void)
{
	DDRA |= (1 << PA6);
	PORTA &= ~(1 << PA6);
}

void init_buttons(void) {
	DDRB &= ~(1 << PB5); // UP
	DDRB &= ~(1 << PB6); // LEFT
	DDRB &= ~(1 << PB7); // RIGHT
	DDRA &= ~(1 << PA7); // SELECT
	DDRD &= ~(1 << PD0); // DOWN


	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
	PORTA |= (1 << PA7);
	PORTD |= (1 << PD0);
}

void compute_rgb_led() {
	int i;

	for(i = 0; i < 30; i++) {
		
		PORTA &= ~(1 << PA2);
		_delay_ms(1000);
		PORTA |= (1 << PA2);
		_delay_ms(1000);
		PORTA &= ~(1 << PA1);
		 _delay_ms(1000);
		PORTA |= (1 << PA1);
		 _delay_ms(1000);
		PORTA &= ~(1 << PA0);
		_delay_ms(1000);
		PORTA |= (1 << PA0);
		 _delay_ms(1000);
		
	}
}

void led_game_over() {
	PORTA |= (1 << PA5);
	_delay_ms(1000);
	PORTA &= ~(1 << PA5);
	_delay_ms(1000);
	PORTA |= (1 << PA4);
	_delay_ms(1000);
	PORTA &= ~(1 << PA4);
	_delay_ms(1000);
	PORTA |= (1 << PA3);
	_delay_ms(1000);
	PORTA &= ~(1 << PA3);
	_delay_ms(1000);
}

void game_over(void) {
	int i = 0;

	while (i < BLOCK_SIZE + 1) {
		nokia_lcd_clear();
		nokia_lcd_set_cursor(10, i * 5);
		nokia_lcd_write_string("YOU LOSE! :(",1);
		nokia_lcd_render();
		melody3();
		led_game_over();
		_delay_ms(100);
		i++;
	}
	finished = 1;

}

void led_life() {

	if (alive == 2) {
		PORTA &= ~(1 << PA5);
		tone3();
		tone2();
		tone1();
		snake_size = INITIAL_SIZE;
		tail = (head - 3) % MAX_SIZE;
	}
	else if (alive == 1) {
		PORTA &= ~(1 << PA4);
		tone3();
		tone2();
		tone1();
		snake_size = INITIAL_SIZE;
		tail = (head - 3) % MAX_SIZE;
	}
	else if (alive == 0) {
		PORTA &= ~(1 << PA3);
		game_over();
	}	
}

void led_life_on() {

	if (alive == 2) {
		PORTA |= (1 << PA5);
	}
	else if (alive == 1) {
		PORTA |= (1 << PA4);
	}	
}

void init_life() {
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA3);
}

void init_leds_word() {
	DDRA |= (1 << PA5);
	PORTA &= ~(1 << PA5);
	DDRA |= (1 << PA4);
	PORTA &= ~(1 << PA4);
	DDRA |= (1 << PA3);
	PORTA &= ~(1 << PA3);
	DDRA |= (1 << PA2);
	PORTA |= (1 << PA2);
	DDRA |= (1 << PA1);
	PORTA |= (1 << PA1);
	DDRA |= (1 << PA0);
	PORTA |= (1 << PA0);
}



void led_food() {
	PORTA &= ~(1 << PA1);
	_delay_ms(1000);
	PORTA |= (1 << PA1);
	_delay_ms(1000);
}

void led_trap() {
	PORTA &= ~(1 << PA0);
	_delay_ms(1000);
	PORTA |= (1 << PA0);
	_delay_ms(1000);
}


void led_extra_food() {
	PORTA &= ~(1 << PA2);
	if (start == 1)
		_delay_ms(5000);
	else
		_delay_ms(1000);
	PORTA |= (1 << PA2);
	if (start == 1)
		_delay_ms(5000);
	else
		_delay_ms(1000);
}

int in_snake(coord gen_food) {
	int i;
	i = tail;
   	while(1) {
   		
   		if (snake[i].x == gen_food.x && snake[i].y == gen_food.y) {
   				return 1;
   		}
		if (i == head)
			break;
		i = (i+1) % MAX_SIZE;
	}
	return 0;
}

coord generate_food() {

	coord aux;
	while (1) {
		aux.x = rand() % WIDTH - 2 * BLOCK_SIZE;
		aux.y = rand() % HEIGHT - (2 * BLOCK_SIZE + 1);
		if ((aux.x % 4 == 0) && (aux.y % 5 == 0))
			if (aux.y > 10 && aux.y < 36)
				if (aux.x > 8 && aux.x < 76 )
					if (in_snake(aux) == 0)
						break;
	}
	return aux;
}

void init_snake()
{
	uint8_t i;
	for (i = 0; i < MAX_SIZE; i++) {
		snake[i].x = -1;
		snake[i].y = -1; 
	}
	for (i = 0; i < INITIAL_SIZE; i++) {
		snake[i].x = HEIGHT / 2 + i * BLOCK_SIZE;
		snake[i].y = HEIGHT / 2 + 1; 
	}
	srand(42);
	head = 2;
	tail = 0;
	food = generate_food();
	extra_food.x = -1;
	extra_food.y = -1;
	magic_food.x = -1;
	magic_food.y = -1;
	extra_life.x = -1;
	extra_life.y = -1;
	if (level == 2 || level == 3) {
		trap.x = -1;
		trap.y = -1;
	}
	snake_size = INITIAL_SIZE;
}

void draw_snake()
{

	int i;
    nokia_lcd_clear();

    nokia_lcd_set_cursor(0, 0);
    nokia_lcd_write_string("Score: ", 1);
	//itoa(snum, score, 10);
	nokia_lcd_set_cursor(37, 0);
	nokia_lcd_write_string(itoa(score, buff, 10), 1);

	if (alive == 3) {
		nokia_lcd_set_cursor(60, 0);
		nokia_lcd_write_string("+++", 1);
	}
	if (alive == 2) {
		nokia_lcd_set_cursor(60, 0);
		nokia_lcd_write_string(" ++", 1);
	}
	if (alive == 1) {
		nokia_lcd_set_cursor(60, 0);
		nokia_lcd_write_string("  +", 1);
	}

    i = tail;
   	while(1) {

		nokia_lcd_set_cursor(snake[i].x, snake[i].y);
		nokia_lcd_write_string("*", 1);
		if (i == head)
			break;
		i = (i+1) % MAX_SIZE;
    }

    nokia_lcd_set_cursor(food.x, food.y);
	nokia_lcd_write_string("$", 1);


    if (extra_food.x != -1) {
   		nokia_lcd_set_cursor(extra_food.x, extra_food.y);
		nokia_lcd_write_string("@", 1);
	}

	if (magic_food.x != -1) {
   		nokia_lcd_set_cursor(magic_food.x, magic_food.y);
		nokia_lcd_write_string("&", 1);
	}
	if (extra_life.x != -1) {
   		nokia_lcd_set_cursor(extra_life.x, extra_life.y);
		nokia_lcd_write_string("+", 1);
	}
	if (level == 2 || level == 3)
		if (trap.x != -1) {
	   		nokia_lcd_set_cursor(trap.x, trap.y);
			nokia_lcd_write_string("X", 1);
		}
    nokia_lcd_render();
}

void snake_bites_itself() {
	int i;
	i = tail;
   	while(1) {
   		if (i == head)
			break;
   		if (snake[head].x == snake[i].x && snake[head].y == snake[i].y) {
   				alive--;
   				led_life();
   		}
		
		i = (i+1) % MAX_SIZE;
	}
	
}

void game()
{
	int ok = 0, magic = 0, count = 0, life = 0, trapp = 0;
	while (1) {
		if (alive == 0)
			break;
		draw_snake();
		int i;

		for (i = 0; i < MAX_SIZE; i++) {
			if ((PINB & (1 << PB6)) == 0 && direction != RIGHT ) {
				direction = LEFT;
			}
			else if ((PINB & (1 << PB5)) == 0 && direction != DOWN ) {
				direction = UP;
			}
			else if ((PINB & (1 << PB7)) == 0 && direction != LEFT ) {
				direction = RIGHT;
			}
			else if ((PINA & (1 << PA7)) == 0 && direction != UP ) {
				direction = DOWN;
			}
			else if ((PIND & (1 << PD0)) == 0) {
				_delay_ms(1000);
				while (1) {
					nokia_lcd_clear();
					nokia_lcd_set_cursor(10, 10);
					nokia_lcd_write_string("PAUSE!", 1);
					nokia_lcd_set_cursor(0, 20);
					nokia_lcd_write_string("Press SELECT", 1);
					nokia_lcd_set_cursor(0, 30);
					nokia_lcd_write_string("to continue!", 1);
					nokia_lcd_render();
					if ((PIND & (1 << PD0)) == 0) {
						_delay_ms(1000);
						break;
					}
				}
			}
			if (level == 3) {
				if (score < 50)
					_delay_ms(50);
				else if (score < 100)
					_delay_ms(45);
				else if (score < 150)
					_delay_ms(40);
				else if (score < 200)
					_delay_ms(35);
				else if (score < 250)
					_delay_ms(30);
				else
					_delay_ms(25);
			} else {
				_delay_ms(50);
			}
		}	

		last_head = head;
		head = (head + 1) % MAX_SIZE;
		snake[head] = snake[last_head];

		if (direction == UP) {
			if (snake[head].y <= 2 * (BLOCK_SIZE+ 1)) {
				snake[head].y = HEIGHT - 2 * (BLOCK_SIZE + 1);
 			} else {
				snake[head].y -= (BLOCK_SIZE + 1);
			}
		} else if (direction == DOWN) {
			if (snake[head].y >= HEIGHT - 2 * (BLOCK_SIZE + 1)) {
				snake[head].y =  2 * (BLOCK_SIZE + 1);
 			} else {
				snake[head].y += (BLOCK_SIZE + 1);
			}

		} else if (direction == LEFT) {
			if (snake[head].x <= BLOCK_SIZE) {
				snake[head].x = WIDTH - 2 *  BLOCK_SIZE;
 			} else {
				snake[head].x -= BLOCK_SIZE;
			}
		} else if (direction == RIGHT) {
			if (snake[head].x >= WIDTH - 2 * BLOCK_SIZE) {
				snake[head].x = 2 * BLOCK_SIZE;
 			} else {
				snake[head].x += BLOCK_SIZE;
			}
		}
			
		tail = (tail + 1) % MAX_SIZE;
		snake_bites_itself();

		 if (abs(food.x - snake[head].x) < BLOCK_SIZE && abs(food.y - snake[head].y) < (BLOCK_SIZE + 1)) {
        	++snake_size;
        	food = generate_food();
        	tail = (tail -1) % MAX_SIZE;
        	led_food();
        	music_play(400,1660);
        	music_play(400,1244);
        	music_play(1046, 50);
        	score += 10;
        	count++;
        }

        if (score % extraFood == 0 && ok == 0 && score > 20) {
        	ok = 1;
        	extra_food = generate_food();
        	count = 0;
        }

        if (score % magicFood == 0 && magic == 0 && score > 20) {
        	magic = 1;
        	magic_food = generate_food();
        	count = 0;
        }

        if (score % extraLife == 0 && life == 0 && score > 20 && alive < 3) {
        	life = 1;
        	extra_life = generate_food();
        	count = 0;
        }

        if (level == 2 || level == 3)
	        if (score % Trap == 0 && trapp == 0 && score > 20) {
	        	trapp = 1;
	        	trap = generate_food();
	        	count = 0;
	        }
       

        if (extra_food.x != -1) {
        	 if (abs(extra_food.x - snake[head].x) < BLOCK_SIZE && abs(extra_food.y - snake[head].y) < (BLOCK_SIZE + 1)) {
	        	tail = (tail -1) % MAX_SIZE;
	        	led_extra_food();
	   			music_play(400,1660);
	   			music_play(600,1060);
	   			music_play(800,860);
	   			music_play(600,1060);
	   			music_play(400,1660);
	        	score += 20;
	        	extra_food.x =-1;
	        	ok = 0;
        	}
        }

         if (magic_food.x != -1) {
        	 if (abs(magic_food.x - snake[head].x) < BLOCK_SIZE && abs(magic_food.y - snake[head].y) < (BLOCK_SIZE + 1)) {
	        	led_extra_food();
	   			music_play(400,1460);
	   			music_play(600,1860);
	   			music_play(1000,860);
	   			music_play(700,1260);
	   			music_play(1200,1060);
	        	score += 30;
	        	magic_food.x = -1;
	        	snake_size = INITIAL_SIZE;
				tail = (head - 2) % MAX_SIZE;
	        	magic = 0;
        	}
        }

          if (extra_life.x != -1) {
        	 if (abs(extra_life.x - snake[head].x) < BLOCK_SIZE && abs(extra_life.y - snake[head].y) < (BLOCK_SIZE + 1)) {
	        	led_extra_food();
	   			music_play(200,800);
	   			music_play(400,875);
	   			music_play(1000,860);
	   			music_play(1400,1360);
	   			music_play(1250,1160);
	        	extra_life.x = -1;
	        	led_life_on();
	        	alive++;
	        	life = 0;
        	}
        }

        if (level == 2 || level == 3)
	        if (trap.x != -1) {
	        	 if (abs(trap.x - snake[head].x) < BLOCK_SIZE && abs(trap.y - snake[head].y) < (BLOCK_SIZE + 1)) {
		        	led_trap();
		   			tone3();
		   			tone2();
		   			tone1();
		        	trap.x = -1;
		        	score -= 20;
		        	alive--;
   					led_life();
		        	trapp = 0;
	        	}
        }

        if (score >= score_win) {

        	int i = 0;

			while (i < BLOCK_SIZE - 1) {
				nokia_lcd_clear();
				nokia_lcd_set_cursor(10, 10 + 4 * i);
				nokia_lcd_write_string("YOU WIN! :)",1);
				nokia_lcd_set_cursor(10, 20 + 4 * i);
			    nokia_lcd_write_string("Score: ", 1);
				nokia_lcd_set_cursor(45, 20 + 4 * i);
				nokia_lcd_write_string(itoa(score, buff, 10), 1);
				nokia_lcd_render();
				melody1();
				i++;
			}
			compute_rgb_led();
			finished = 1;
        	break;
        } 

        if (count == 2) {
        	magic = 0;
        	ok = 0;
        	life = 0;
        	trapp = 0;
        	magic_food.x = -1;
        	extra_food.x = -1;
        	extra_life.x = -1;
        	trap.x = -1;
        }

	}

}


int main(void)
{
    nokia_lcd_init();
    nokia_lcd_clear();
	init_buttons();
	init_leds_word();
	buzzer_init();
	
	while (1) {
		finished = 0;
		alive = 3;
		score = 0;
		level = 0;
		nokia_lcd_clear();
		nokia_lcd_set_cursor(15, 0);
	    nokia_lcd_write_string("AVR Snake", 1);
	    nokia_lcd_set_cursor(0, 8);
	    nokia_lcd_write_string("Marin Maria", 1);
	    nokia_lcd_set_cursor(0, 16);
	    nokia_lcd_write_string("Georgiana", 1);
	    nokia_lcd_set_cursor(0, 24);
	    nokia_lcd_write_string("334CC", 1);
	     nokia_lcd_set_cursor(0, 32);
	    nokia_lcd_write_string("Press Select", 1);
	    nokia_lcd_render();
	    melody2();
	    start = 1;

	    while (1) { 
	    	led_extra_food();

	    	if ((PIND & (1 << PD0)) == 0) {
	    		start = 0;
				nokia_lcd_clear();
				nokia_lcd_set_cursor(0, 1);
				nokia_lcd_write_string("MENIU", 1);
				nokia_lcd_set_cursor(0, 14);
				nokia_lcd_write_string("1-EASY LEFT!", 1);
				nokia_lcd_set_cursor(0, 24);
				nokia_lcd_write_string("2-MEDIU UP!", 1);
				nokia_lcd_set_cursor(0, 34);
				nokia_lcd_write_string("3-HARD RIGHT!", 1);
				nokia_lcd_render();
			}
			if ((PINB & (1 << PB6)) == 0) {
				level = 1;
				score_win = 200;
				extraFood = 40;
				magicFood = 60;
				extraLife = 70;
				nokia_lcd_clear();
				nokia_lcd_set_cursor(30, 20);
				nokia_lcd_write_string("GOOD", 1);
				nokia_lcd_set_cursor(30, 30);
				nokia_lcd_write_string("LUCK!", 1);
				nokia_lcd_render();
				_delay_ms(1000);
				break;
			}
			if ((PINB & (1 << PB5)) == 0) {
				level = 2;
				score_win = 300;
				extraFood = 70;
				magicFood = 150;
				extraLife = 190;
				Trap = 90;
				nokia_lcd_clear();
				nokia_lcd_set_cursor(30, 20);
				nokia_lcd_write_string("GOOD", 1);
				nokia_lcd_set_cursor(30, 30);
				nokia_lcd_write_string("LUCK!", 1);
				nokia_lcd_render();
				_delay_ms(1000);
				break;
			}
			if ((PINB & (1 << PB7)) == 0) {
				level = 3;
				score_win = 500;
				extraFood = 70;
				magicFood = 150;
				extraLife = 190;
				Trap = 70;
				nokia_lcd_clear();
				nokia_lcd_set_cursor(30, 20);
				nokia_lcd_write_string("GOOD", 1);
				nokia_lcd_set_cursor(30, 30);
				nokia_lcd_write_string("LUCK!", 1);
				nokia_lcd_render();
				_delay_ms(1000);
				break;
			}
	    }

	    init_snake();
	    init_life();

	    game();

	    if (finished == 1) {
	    	nokia_lcd_clear();
				nokia_lcd_set_cursor(0, 10);
				nokia_lcd_write_string("Try again?", 1);
				nokia_lcd_set_cursor(0, 30);
				nokia_lcd_write_string("Press Select!", 1);
				nokia_lcd_render();

				while (((PIND & (1 << PD0)) != 0));
	    }
		}
	return 0;
}